﻿using CallCenter.Calls;
using XF.Domain.Cache;
using XF.Domain.Dependency;

namespace CallCenter.Caches
{
    public class CallCacheManager : ICallCacheManager, IScopeDependency
    {
        private readonly ITypedCache<CallDtoRedis> _cacheCall;

        public class CallDtoRedis
        {
            public string FromNo { get; set; }
            public string ToNo { get; set; }
            public DateTime InGroupTime { get; set; }
        }

        public CallCacheManager(ITypedCache<CallDtoRedis> cacheCall)
        {
            _cacheCall = cacheCall;
        }

        public void AddCallCache(Call call)
        {
            _cacheCall.Set(call.Id,  new CallDtoRedis{ FromNo =call.FromNo,ToNo = call.ToNo, InGroupTime = DateTime.Now });
        }

        public List<CallDtoRedis> GetCallQueueList()
        {
            var list = _cacheCall.GetListByPrefix().ToList();
            return list==null ? new List<CallDtoRedis>() : list;
        }

        public void RemoveCallCache(string id)
        {
            _cacheCall.Remove(id);
        }
    }
}
